%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%setup paths and libraries, reads data
setup;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%initializes neural net structure
initializeCNN;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% directory where to store output
outsubDir = fullfile('data','exp1');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% options for training neural network
trainOpts.batchSize = 50 ;  
trainOpts.learningRate = 0.001 ;
trainOpts.numEpochs = 10 ;
trainOpts.expDir = fullfile(outsubDir) ;
trainOpts.continue = false ;
trainOpts.useGpu = false ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Train neural network
[net,info] = cnn_trainMy(net, imdb, @getBatch, trainOpts) ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% remove the last layer, do not need it for classification
net.layers(end) = [] ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% saves the network for possible later use
save(fullfile(outsubDir,'/myNet.mat'), '-struct', 'net') ;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Now apply network to the test data
res = vl_simplenn(net, X_Test);

for i=1:size(res(end).x,4)
  [score(i),pred(i)] = max(squeeze(res(end).x(1,1,:,i))) ;
end

% compute classification error 
d = (pred-Y_Test');
i = find(d ~= 0 );
err =size(i,2)/size(pred,2);
fprintf('Test error is %f.\n',err);
